diff --git a/src/main/java/net/minecraft/client/gui/GuiIngameDoom.java b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
similarity index 85%
rename from src/main/java/net/minecraft/client/gui/GuiIngameDoom.java
rename to src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
index 81376bfe5..a736165e0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngameDoom.java
+++ b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
@@ -1,339 +1,338 @@
-package net.minecraft.client.gui;
-
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.command.TextFormatting;
-import org.lwjgl.opengl.GL11;
-
-import java.util.ArrayList;
-import java.util.List;
-
-public class GuiIngameDoom
-    extends GuiIngame
-{
-    private static final int[] NUMBER_WIDTHS = {
-            9, 7, 9, 9, 11, 9, 9, 9, 9, 9
-    };
-    private static final int[] NUMBER_US = {
-            0, 9, 16, 25, 34, 45, 54, 63, 72, 81
-    };
-
-    public GuiIngameDoom(Minecraft minecraft) {
-        super(minecraft);
-    }
-
-    @Override
-    public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY)
-    {
-        if (mc.currentScreen instanceof GuiPhotoMode) return;
-
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        FontRenderer fontrenderer = mc.fontRenderer;
-        mc.worldRenderer.setupScaledResolution();
-
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-
-        // Render vignette
-        if (mc.gameSettings.immersiveMode.drawVignette() && mc.gameSettings.vignette.value)
-        {
-            renderVignette(mc.thePlayer.getBrightness(partialTicks), width, height);
-        }
-
-        // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(3);
-        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
-        {
-            renderPumpkinBlur(width, height);
-        }
-
-        // Render portal overlay
-        float portalIntensity = mc.thePlayer.prevTimeInPortal + (mc.thePlayer.timeInPortal - mc.thePlayer.prevTimeInPortal) * partialTicks;
-        if (portalIntensity > 0.0F)
-        {
-            renderPortalOverlay(portalIntensity, width, height);
-        }
-
-        drawBackground();
-        drawFace();
-        drawAmmo();
-        drawHealth();
-        drawArmsButtons();
-        drawArmor();
-        drawHotbarIndicator();
-        drawStacks();
-
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-
-        if (mc.gameSettings.immersiveMode.drawCrosshair() && mc.gameSettings.thirdPersonView.value == 0)
-        {
-            // Render crosshair
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
-            drawGuiIcon(width/2 - 7, height/2 - 7, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
-            GL11.glDisable(GL11.GL_BLEND);
-        }
-    }
-
-    private void drawBackground()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
-
-        // Draw main hotbar
-        drawTexturedModalRect(width / 2 - 197, height - 43, 0, 0, 197, 43);
-        drawTexturedModalRect(width / 2, height - 43, 0, 43, 197, 43);
-
-        // Draw sides
-        drawTexturedModalRect(0d, height - 43, 0, 86, width / 2 - 197, 43, 1, 43);
-        drawTexturedModalRect(width / 2d + 197d, height - 43, 0, 86, width - (width / 2 + 197), 43, 1, 43);
-    }
-
-    private void drawFace()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        Face face = Face.NEUTRAL;
-        if (mc.thePlayer.getGamemode().isPlayerInvulnerable())
-        {
-            face = Face.GOD;
-        }
-        else if (mc.thePlayer.getHealth() == 0)
-        {
-            face = Face.DEAD;
-        }
-        else if (mc.thePlayer.hurtTime > 0)
-        {
-            face = Face.PAIN;
-        }
-        else if (updateCounter % 200 > 175)
-        {
-            face = Face.LOOK_RIGHT;
-        }
-        else if (updateCounter % 200 > 150)
-        {
-            face = Face.LOOK_LEFT;
-        }
-
-        drawTexturedModalRect(width / 2 - 16, height - 36, face.u, face.v, 32, 32);
-    }
-
-    private void drawAmmo()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        ItemStack stack = mc.thePlayer.getHeldItem();
-        if (stack == null) return;
-        int ammo = stack.stackSize;
-
-        drawNumber(ammo, width / 2 - 160, height - 32);
-    }
-
-    private void drawHealth()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        float healthPercentage = mc.thePlayer.getHealth() / (float)mc.thePlayer.getMaxHealth();
-        int health = (int)(healthPercentage * 100);
-        if (health < 0) health = 0;
-
-        drawNumber(health, width / 2 - 116, height - 32);
-    }
-
-    private void drawNumber(int i, int x, int y)
-    {
-        GL11.glColor4f(1f, 1f, 1f, 1f);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
-
-        List<Integer> parts = new ArrayList<>();
-
-        int prev = 0;
-        int mult = 1;
-        while (i / mult != 0)
-        {
-            int lowerDigits = i % (mult * 10);
-            int digit = lowerDigits - prev;
-            prev += digit;
-            parts.add(digit / mult);
-            mult *= 10;
-        }
-
-        for (int digit : parts)
-        {
-            int width = NUMBER_WIDTHS[digit];
-            int u = NUMBER_US[digit];
-            int v = 209;
-            x -= width;
-            drawTexturedModalRect(x, y, u, v, width, 15);
-            x -= 1;
-        }
-    }
-
-    private void drawArmsButtons()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        int i = 1;
-        int activeSlot = mc.thePlayer.inventory.currentItem % 9;
-        for (int y = 0; y < 2; y++)
-        {
-            for (int x = 0; x < 5; x++)
-            {
-                if (i >= 10) continue;
-
-                int px = width / 2 - 90 + 14 * x;
-                int py = height - 38 + 14 * y;
-
-                drawArmsButton(px, py, i, i - 1 == activeSlot);
-
-                i++;
-            }
-        }
-    }
-
-    private void drawArmsButton(int x, int y, int number, boolean active)
-    {
-        GL11.glColor4f(1f, 1f, 1f, 1f);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
-
-        int u = 13;
-        int v = 196;
-        int textColor = 0xFFFFFFFF;
-
-        if (active)
-        {
-            u = 0;
-            textColor = 0xFFA0A0A0;
-        }
-
-        drawTexturedModalRect(x, y, u, v, 13, 13);
-        drawString(fontrenderer, Integer.toString(number % 10), x + 4, y + 3, textColor);
-    }
-
-    private void drawArmor()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        float armorPercentage = mc.thePlayer.getPlayerProtectionAmount() / 20f;
-        int armor = (int)(armorPercentage * 100);
-
-        drawNumber(armor, width / 2 + 48, height - 32);
-    }
-
-    private void drawHotbarIndicator()
-    {
-//        GL11.glColor4f(1f, 1f, 1f, 1f);
-//        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/doom.png"));
-
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        int x = width / 2 + 76;
-        int y = height - 36;
-
-        int selectedHotbar = ((mc.thePlayer.inventory.hotbarOffset + 27) % 36) / 9;
-
-        drawTexturedModalRect(x, y + 9 * selectedHotbar, 0, 129, 6, 6);
-    }
-
-    private void drawStacks()
-    {
-        int width = mc.resolution.scaledWidth;
-        int height = mc.resolution.scaledHeight;
-
-        int currentItem = mc.thePlayer.inventory.currentItem;
-        int wrappedCurrentItem = mc.thePlayer.inventory.currentItem % 9;
-
-        int offset = 0;
-        if (wrappedCurrentItem >= 5)
-        {
-            offset = 3 - (8 - wrappedCurrentItem);
-        }
-
-        int q = 0;
-        for (int i = currentItem - offset; i < currentItem - offset + 4; i++)
-        {
-            ItemStack stack = mc.thePlayer.inventory.getItem(i);
-            int x = width / 2 + 94;
-            int y = height - 37 + q * 9;
-
-            drawItemStack(stack, x, y, i == currentItem);
-
-            q++;
-        }
-    }
-
-    private void drawItemStack(ItemStack stack, int x, int y, boolean selected)
-    {
-        if (stack == null) return;
-        String name = stack.getDisplayName();
-        
-        if (name.length() >= 10) name = name.substring(0, 10);
-        name = name.toUpperCase();
-        if (selected)
-        {
-            drawString(fontrenderer, TextFormatting.get(stack.getDisplayColor()) + name, x, y, 0xFFFFFFFF);
-        }
-        else
-        {
-            drawStringNoShadow(fontrenderer, name, x, y, 0xFF404040);
-        }
-
-        int maxStackSize = stack.getMaxStackSize();
-        int stackSize = stack.stackSize;
-
-        // Draw stack size
-        if (stackSize < 10)
-        {
-            drawString(fontrenderer, Integer.toString(stackSize), x + 70, y, 0xFFFFFFA0);
-        }
-        else
-        {
-            drawString(fontrenderer, Integer.toString(stackSize), x + 64, y, 0xFFFFFFA0);
-        }
-
-        // Draw max stack size
-        if (maxStackSize < 10)
-        {
-            drawString(fontrenderer, Integer.toString(maxStackSize), x + 88, y, 0xFFFFFFA0);
-        }
-        else
-        {
-            drawString(fontrenderer, Integer.toString(maxStackSize), x + 82, y, 0xFFFFFFA0);
-        }
-    }
-
-    private enum Face
-    {
-        NEUTRAL(0, 224),
-        LOOK_RIGHT(32, 224),
-        LOOK_LEFT(64, 224),
-        GRIN(96, 224),
-        PAIN(128, 224),
-        BIG_PAIN(160, 224),
-        GOD(192, 224),
-        DEAD(224, 224);
-
-        public final int u;
-        public final int v;
-
-        Face(int u, int v)
-        {
-            this.u = u;
-            this.v = v;
-        }
-    }
-}
+package net.minecraft.client.gui.hud;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.TextFormatting;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class DoomIngameHud
+    extends IngameHud
+{
+    private static final int[] NUMBER_WIDTHS = {
+            9, 7, 9, 9, 11, 9, 9, 9, 9, 9
+    };
+    private static final int[] NUMBER_US = {
+            0, 9, 16, 25, 34, 45, 54, 63, 72, 81
+    };
+
+    public DoomIngameHud(Minecraft minecraft) {
+        super(minecraft);
+    }
+
+    @Override
+    public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY)
+    {
+        if (mc.currentScreen instanceof PhotoModeScreen) return;
+
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        mc.worldRenderer.setupScaledResolution();
+
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+
+        // Render vignette
+        if (mc.gameSettings.immersiveMode.drawVignette() && mc.gameSettings.vignette.value)
+        {
+            renderVignette(mc.thePlayer.getBrightness(partialTicks), width, height);
+        }
+
+        // Render pumpkin overlay
+        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(3);
+        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
+        {
+            renderPumpkinBlur(width, height);
+        }
+
+        // Render portal overlay
+        float portalIntensity = mc.thePlayer.prevTimeInPortal + (mc.thePlayer.timeInPortal - mc.thePlayer.prevTimeInPortal) * partialTicks;
+        if (portalIntensity > 0.0F)
+        {
+            renderPortalOverlay(portalIntensity, width, height);
+        }
+
+        drawBackground();
+        drawFace();
+        drawAmmo();
+        drawHealth();
+        drawArmsButtons();
+        drawArmor();
+        drawHotbarIndicator();
+        drawStacks();
+
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+
+        if (mc.gameSettings.immersiveMode.drawCrosshair() && mc.gameSettings.thirdPersonView.value == 0)
+        {
+            // Render crosshair
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
+            drawGuiIcon(width/2 - 7, height/2 - 7, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
+            GL11.glDisable(GL11.GL_BLEND);
+        }
+    }
+
+    private void drawBackground()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
+
+        // Draw main hotbar
+        drawTexturedModalRect(width / 2 - 197, height - 43, 0, 0, 197, 43);
+        drawTexturedModalRect(width / 2, height - 43, 0, 43, 197, 43);
+
+        // Draw sides
+        drawTexturedModalRect(0d, height - 43, 0, 86, width / 2 - 197, 43, 1, 43);
+        drawTexturedModalRect(width / 2d + 197d, height - 43, 0, 86, width - (width / 2 + 197), 43, 1, 43);
+    }
+
+    private void drawFace()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        Face face = Face.NEUTRAL;
+        if (mc.thePlayer.getGamemode().isPlayerInvulnerable())
+        {
+            face = Face.GOD;
+        }
+        else if (mc.thePlayer.getHealth() == 0)
+        {
+            face = Face.DEAD;
+        }
+        else if (mc.thePlayer.hurtTime > 0)
+        {
+            face = Face.PAIN;
+        }
+        else if (updateCounter % 200 > 175)
+        {
+            face = Face.LOOK_RIGHT;
+        }
+        else if (updateCounter % 200 > 150)
+        {
+            face = Face.LOOK_LEFT;
+        }
+
+        drawTexturedModalRect(width / 2 - 16, height - 36, face.u, face.v, 32, 32);
+    }
+
+    private void drawAmmo()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        ItemStack stack = mc.thePlayer.getHeldItem();
+        if (stack == null) return;
+        int ammo = stack.stackSize;
+
+        drawNumber(ammo, width / 2 - 160, height - 32);
+    }
+
+    private void drawHealth()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        float healthPercentage = mc.thePlayer.getHealth() / (float)mc.thePlayer.getMaxHealth();
+        int health = (int)(healthPercentage * 100);
+        if (health < 0) health = 0;
+
+        drawNumber(health, width / 2 - 116, height - 32);
+    }
+
+    private void drawNumber(int i, int x, int y)
+    {
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
+
+        List<Integer> parts = new ArrayList<>();
+
+        int prev = 0;
+        int mult = 1;
+        while (i / mult != 0)
+        {
+            int lowerDigits = i % (mult * 10);
+            int digit = lowerDigits - prev;
+            prev += digit;
+            parts.add(digit / mult);
+            mult *= 10;
+        }
+
+        for (int digit : parts)
+        {
+            int width = NUMBER_WIDTHS[digit];
+            int u = NUMBER_US[digit];
+            int v = 209;
+            x -= width;
+            drawTexturedModalRect(x, y, u, v, width, 15);
+            x -= 1;
+        }
+    }
+
+    private void drawArmsButtons()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        int i = 1;
+        int activeSlot = mc.thePlayer.inventory.currentItem % 9;
+        for (int y = 0; y < 2; y++)
+        {
+            for (int x = 0; x < 5; x++)
+            {
+                if (i >= 10) continue;
+
+                int px = width / 2 - 90 + 14 * x;
+                int py = height - 38 + 14 * y;
+
+                drawArmsButton(px, py, i, i - 1 == activeSlot);
+
+                i++;
+            }
+        }
+    }
+
+    private void drawArmsButton(int x, int y, int number, boolean active)
+    {
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
+
+        int u = 13;
+        int v = 196;
+        int textColor = 0xFFFFFFFF;
+
+        if (active)
+        {
+            u = 0;
+            textColor = 0xFFA0A0A0;
+        }
+
+        drawTexturedModalRect(x, y, u, v, 13, 13);
+        drawString(font, Integer.toString(number % 10), x + 4, y + 3, textColor);
+    }
+
+    private void drawArmor()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        float armorPercentage = mc.thePlayer.getPlayerProtectionAmount() / 20f;
+        int armor = (int)(armorPercentage * 100);
+
+        drawNumber(armor, width / 2 + 48, height - 32);
+    }
+
+    private void drawHotbarIndicator()
+    {
+//        GL11.glColor4f(1f, 1f, 1f, 1f);
+//        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/doom.png"));
+
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        int x = width / 2 + 76;
+        int y = height - 36;
+
+        int selectedHotbar = ((mc.thePlayer.inventory.hotbarOffset + 27) % 36) / 9;
+
+        drawTexturedModalRect(x, y + 9 * selectedHotbar, 0, 129, 6, 6);
+    }
+
+    private void drawStacks()
+    {
+        int width = mc.resolution.scaledWidth;
+        int height = mc.resolution.scaledHeight;
+
+        int currentItem = mc.thePlayer.inventory.currentItem;
+        int wrappedCurrentItem = mc.thePlayer.inventory.currentItem % 9;
+
+        int offset = 0;
+        if (wrappedCurrentItem >= 5)
+        {
+            offset = 3 - (8 - wrappedCurrentItem);
+        }
+
+        int q = 0;
+        for (int i = currentItem - offset; i < currentItem - offset + 4; i++)
+        {
+            ItemStack stack = mc.thePlayer.inventory.getItem(i);
+            int x = width / 2 + 94;
+            int y = height - 37 + q * 9;
+
+            drawItemStack(stack, x, y, i == currentItem);
+
+            q++;
+        }
+    }
+
+    private void drawItemStack(ItemStack stack, int x, int y, boolean selected)
+    {
+        if (stack == null) return;
+        String name = stack.getDisplayName();
+        
+        if (name.length() >= 10) name = name.substring(0, 10);
+        name = name.toUpperCase();
+        if (selected)
+        {
+            drawString(font, TextFormatting.get(stack.getDisplayColor()) + name, x, y, 0xFFFFFFFF);
+        }
+        else
+        {
+            drawStringNoShadow(font, name, x, y, 0xFF404040);
+        }
+
+        int maxStackSize = stack.getMaxStackSize();
+        int stackSize = stack.stackSize;
+
+        // Draw stack size
+        if (stackSize < 10)
+        {
+            drawString(font, Integer.toString(stackSize), x + 70, y, 0xFFFFFFA0);
+        }
+        else
+        {
+            drawString(font, Integer.toString(stackSize), x + 64, y, 0xFFFFFFA0);
+        }
+
+        // Draw max stack size
+        if (maxStackSize < 10)
+        {
+            drawString(font, Integer.toString(maxStackSize), x + 88, y, 0xFFFFFFA0);
+        }
+        else
+        {
+            drawString(font, Integer.toString(maxStackSize), x + 82, y, 0xFFFFFFA0);
+        }
+    }
+
+    private enum Face
+    {
+        NEUTRAL(0, 224),
+        LOOK_RIGHT(32, 224),
+        LOOK_LEFT(64, 224),
+        GRIN(96, 224),
+        PAIN(128, 224),
+        BIG_PAIN(160, 224),
+        GOD(192, 224),
+        DEAD(224, 224);
+
+        public final int u;
+        public final int v;
+
+        Face(int u, int v)
+        {
+            this.u = u;
+            this.v = v;
+        }
+    }
+}
